// -*- C++ -*-
/*!
 * @file  SelfCameraManager.cpp
 * @brief Self Camera Manager
 * @date $Date$
 *
 * $Id$
 */

#include "SelfCameraManager.h"

// Module specification
// <rtc-template block="module_spec">
static const char* selfcameramanager_spec[] =
  {
    "implementation_id", "SelfCameraManager",
    "type_name",         "SelfCameraManager",
    "description",       "Self Camera Manager",
    "version",           "1.0.0",
    "vendor",            "VenderName",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
SelfCameraManager::SelfCameraManager(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_saveImageFlgIn("saveImageFlg", m_saveImageFlg),
    m_centerFlgIn("centerFlg", m_centerFlg),
    m_commandIn("command", m_command),
    m_facesIn("faces", m_faces),
    m_setSaveImageFlgOut("setSaveImageFlg", m_setSaveImageFlg),
    m_switchCameraIDOut("switchCameraID", m_switchCameraID),
    m_modeFlgOut("modeFlg", m_modeFlg),
    m_speechTextOut("speechText", m_speechText)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
SelfCameraManager::~SelfCameraManager()
{
}



RTC::ReturnCode_t SelfCameraManager::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("saveImageFlg", m_saveImageFlgIn);
  addInPort("centerFlg", m_centerFlgIn);
  addInPort("command", m_commandIn);
  addInPort("faces", m_facesIn);
  
  // Set OutPort buffer
  addOutPort("setSaveImageFlg", m_setSaveImageFlgOut);
  addOutPort("switchCameraID", m_switchCameraIDOut);
  addOutPort("modeFlg", m_modeFlgOut);
  addOutPort("speechText", m_speechTextOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t SelfCameraManager::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SelfCameraManager::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SelfCameraManager::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t SelfCameraManager::onActivated(RTC::UniqueId ec_id)
{	
	//
	centerFlg = 0;//2:Z^[ 1:ʂɂȂɊ炪@0:炪fĂȂ
	modeFlg = 1;//T
	snupFlg = 0;//1:Ƃ
	cameraID = 1;
	saveImageFlg = 0;
	faces = 0;
	newCommand = 0;//VR}hP
			
  return RTC::RTC_OK;										
}


RTC::ReturnCode_t SelfCameraManager::onDeactivated(RTC::UniqueId ec_id)
{


  return RTC::RTC_OK;
}


RTC::ReturnCode_t SelfCameraManager::onExecute(RTC::UniqueId ec_id)
{



	
	//f[^|[gǂݍ
	if (m_commandIn.isNew())
	{
		while (!m_commandIn.isEmpty())
		{
			m_commandIn.read();
		}
		command = m_command.data;
		newCommand = 1;
	}

	if (m_saveImageFlgIn.isNew())
	{
		while (!m_saveImageFlgIn.isEmpty())
		{
			m_saveImageFlgIn.read();

		}
		saveImageFlg = m_saveImageFlg.data;
	}
	
	if (m_facesIn.isNew())
	{
		while (!m_facesIn.isEmpty())
		{
			m_facesIn.read();
		}
		faces = m_faces.data;
	}

	if (m_centerFlgIn.isNew())
	{
		while (!m_centerFlgIn.isEmpty())
		{
			m_centerFlgIn.read();
		}
		centerFlg = m_centerFlg.data;

	}

	std::cout << "̈ʒuFOڂĂȂ@Pʓ@Q^ :" << centerFlg << std::endl;
	std::cout << "[hF@O~Eb@PT@QBe@@ :" << modeFlg << std::endl;
	std::cout << "B^C~OF@OBȂ@PB@@@@@ :" << snupFlg << std::endl;
	std::cout << "FJFPTp@QBp       :" << cameraID << std::endl;
	std::cout << "R}hǂ@@@@@@@@@@@@@@ :" << newCommand << std::endl << std::endl << std::endl;

	Sleep(100);
	//[hT[hBe[hɕύX
	if (modeFlg == 0&& snupFlg == 0)
	{
		if (newCommand)
		{
			if (command == "OK")
			{
				modeFlg = 2;
				cameraID = 2;

				m_modeFlg.data = modeFlg;
				m_modeFlgOut.write();
				m_switchCameraID.data = cameraID;
				m_switchCameraIDOut.write();
				
				
				speechOut = "܂|[YƂ̂Ł@ʐ^ɓĂ";

				speechOut = SjistoUTF8(speechOut);
				m_speechText.data = speechOut.c_str();
				setTimestamp(m_speechText);
				m_speechTextOut.write();
				
			}
			else if (command == "NG")
			{
				modeFlg = 1;
				m_modeFlg.data = modeFlg;
				m_modeFlgOut.write();
			
				speechOut = "͂˂ł";

				speechOut = SjistoUTF8(speechOut);
				m_speechText.data = speechOut.c_str();
				setTimestamp(m_speechText);
				m_speechTextOut.write();
				
			}
			
			newCommand = 0;
		}
	}

	//Z^[ꍇ
	if (centerFlg==2)
	{
		if (modeFlg == 1)//T[h
		{
			//{bgɂ̏Œ~Ă炤

			modeFlg = 0;
			m_modeFlg.data = modeFlg;
			m_modeFlgOut.write();

			//BeĂ
			speechOut = "Ăł";

			speechOut = SjistoUTF8(speechOut);
			m_speechText.data = speechOut.c_str();
			setTimestamp(m_speechText);
			m_speechTextOut.write();
			Sleep(1500);
			//OĂĂR}hZbg
			if (m_commandIn.isNew())
			{
				while (!m_commandIn.isEmpty())
				{
					m_commandIn.read();
				}
				command = m_command.data;
				
			}
			newCommand = 0;

		}
		else if (modeFlg == 2)//Be[h
		{
			//{bgɂ̏Œ~Ă炤

			modeFlg = 0;
			m_modeFlg.data = modeFlg;
			m_modeFlgOut.write();


			////////////////////////////////////////////////////////////////////////////////
			speechOut = "Ƃ܂";
			speechOut = SjistoUTF8(speechOut);
			m_speechText.data = speechOut.c_str();
			setTimestamp(m_speechText);
			m_speechTextOut.write();

			Sleep(2000);
			////////////////////////////////////////////////////////////////////////////////
			speechOut = "͂@";
			speechOut = SjistoUTF8(speechOut);
			m_speechText.data = speechOut.c_str();
			setTimestamp(m_speechText);
			m_speechTextOut.write();

			Sleep(1000);
			snupFlg = 1;
			m_setSaveImageFlg.data = snupFlg;
			m_setSaveImageFlgOut.write();

		}
		else if (modeFlg == 0)//bE~
		{
			//Ђ炽
		}
		centerFlg = 0;
	}

	if (saveImageFlg == 1&&snupFlg==1)
	{ //BeƂmFAT[hɂǂ
		snupFlg = 0;
		saveImageFlg = 0;
		m_setSaveImageFlg.data = snupFlg;
		m_setSaveImageFlgOut.write();


		//////////////////////////////////////////////////////////////////////////////////////////
		speechOut = "ႵƂ܂";
		speechOut = SjistoUTF8(speechOut);
		m_speechText.data = speechOut.c_str();
		setTimestamp(m_speechText);
		m_speechTextOut.write();

		Sleep(3000);

		speechOut = "Tɖ߂܂";
		speechOut = SjistoUTF8(speechOut);
		m_speechText.data = speechOut.c_str();
		setTimestamp(m_speechText);
		m_speechTextOut.write();

		Sleep(1000);

		modeFlg = 1;
		m_modeFlg.data = modeFlg;
		m_modeFlgOut.write();

		cameraID = 1;
		m_switchCameraID.data = cameraID;
		m_switchCameraIDOut.write();

	}
	//BeɊ炪fĂȂƂ

	if (modeFlg == 2 && centerFlg == 0)
	{

	}


	
	/*
	//eXgp OpenJtalkւ̓
	std::string testSpeech,dummy;
	testSpeech = "a";
	std::cout << "Speech text" << std::endl;
	std::cin >>testSpeech;
	std::cout << "speech :" << testSpeech << std::endl;

	Sleep(1000);
	
	

	testSpeech=SjistoUTF8(testSpeech);
	


	m_speechText.data = testSpeech.c_str();													  
	setTimestamp(m_speechText);

	m_speechTextOut.write();
	
	*/
	//eXgp F̐
	/**/
	
	


  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t SelfCameraManager::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SelfCameraManager::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SelfCameraManager::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SelfCameraManager::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SelfCameraManager::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

std::string SelfCameraManager::SjistoUTF8(std::string srcSjis)
{
	//Unicode֕ϊ̕񒷂𓾂
	int lenghtUnicode = MultiByteToWideChar(CP_THREAD_ACP, 0, srcSjis.c_str(), srcSjis.size() + 1, NULL, 0);

	//KvȕUnicodẽobt@m
	wchar_t* bufUnicode = new wchar_t[lenghtUnicode];

	//ShiftJISUnicode֕ϊ
	MultiByteToWideChar(CP_THREAD_ACP, 0, srcSjis.c_str(), srcSjis.size() + 1, bufUnicode, lenghtUnicode);


	//UTF8֕ϊ̕񒷂𓾂
	int lengthUTF8 = WideCharToMultiByte(CP_UTF8, 0, bufUnicode, -1, NULL, 0, NULL, NULL);

	//KvȕUTF8̃obt@m
	char* bufUTF8 = new char[lengthUTF8];

	//UnicodeUTF8֕ϊ
	WideCharToMultiByte(CP_UTF8, 0, bufUnicode, lenghtUnicode + 1, bufUTF8, lengthUTF8, NULL, NULL);

	std::string strUTF8(bufUTF8);

	delete bufUnicode;
	delete bufUTF8;

	return strUTF8;
}



extern "C"
{
 
  void SelfCameraManagerInit(RTC::Manager* manager)
  {
    coil::Properties profile(selfcameramanager_spec);
    manager->registerFactory(profile,
                             RTC::Create<SelfCameraManager>,
                             RTC::Delete<SelfCameraManager>);
  }
  
};


